<?php
namespace bwdrpmx_RestPriceMenu_namespace;

use bwdrpmx_RestPriceMenu_namespace\PageSettings\Page_Settings;
define( "bwdrpmx_ASFSK_ASSETS_PUBLIC_DIR_FILE", plugin_dir_url( __FILE__ ) . "assets/public" );
define( "bwdrpmx_ASFSK_ASSETS_ADMIN_DIR_FILE", plugin_dir_url( __FILE__ ) . "assets/admin" );
class Classbwdrpmx_RestPriceMenu {

	private static $_instance = null;

	public static function instance() {
		if ( is_null( self::$_instance ) ) {
			self::$_instance = new self();
		}
		return self::$_instance;
	}

	public function bwdrpmx_admin_editor_scripts() {
		add_filter( 'script_loader_tag', [ $this, 'bwdrpmx_admin_editor_scripts_as_a_module' ], 10, 2 );
	}

	public function bwdrpmx_admin_editor_scripts_as_a_module( $tag, $handle ) {
		if ( 'bwdrpmx_RestPriceMenu_editor' === $handle ) {
			$tag = str_replace( '<script', '<script type="module"', $tag );
		}

		return $tag;
	}

	private function include_widgets_files() {
		require_once( __DIR__ . '/widgets/bwdrpmx-rest-price-menu-widgets.php' );
	}

	public function bwdrpmx_register_widgets() {
		// Its is now safe to include Widgets files
		$this->include_widgets_files();

		// Register WidgetsF
		\Elementor\Plugin::instance()->widgets_manager->register_widget_type( new Widgets\bwdrpmx_RestPriceMenu_widgets());
	}

	private function add_page_settings_controls() {
		require_once( __DIR__ . '/page-settings/bwdrpmx-rest-price-menu-manager.php' );
		new Page_Settings();
	}

	// Register Category
	function bwdrpmx_RestPriceMenu_add_elementor_widget_categories( $elements_manager ) {

		$elements_manager->add_category(
			'bwdrpmx-RestPriceMenu-category',
			[
				'title' => esc_html__( 'Restaurant Price Menu', 'bwdrpmx-price-menu' ),
				'icon' => 'eicon-person',
			]
		);
	}

	//css-js-link-here
	public function bwdrpmx_all_assets_for_the_public(){

		$all_css_file = array(
			'bwdrpmx-RestPriceMenu-plugin-main' => array('bwdrpmx-RestPriceMenu_css_path_define'=>bwdrpmx_ASFSK_ASSETS_PUBLIC_DIR_FILE . '/css/main.css'),
        );
        foreach($all_css_file as $handle => $fileinfo){
            wp_enqueue_style( $handle, $fileinfo['bwdrpmx-RestPriceMenu_css_path_define'], null, '1.3', 'all');
        }

	}

	//admin-icon
	public function bwdrpmx_all_assets_for_elementor_editor_admin(){
		$all_css_js_file = array(
            'bwdrpmx-RestPriceMenu-admin-main' => array('bwdrpmx_path_admin_define'=>bwdrpmx_ASFSK_ASSETS_ADMIN_DIR_FILE . '/css/icon.css'),
        );
        foreach($all_css_js_file as $handle => $fileinfo){
            wp_enqueue_style( $handle, $fileinfo['bwdrpmx_path_admin_define'], null, '1.3', 'all');
        }
	}

	public function __construct() {

		// For public assets
		add_action('wp_enqueue_scripts', [$this, 'bwdrpmx_all_assets_for_the_public']);

		// For Elementor Editor
		add_action('elementor/editor/before_enqueue_scripts', [$this, 'bwdrpmx_all_assets_for_elementor_editor_admin']);

		// Register Category
		add_action( 'elementor/elements/categories_registered', [ $this, 'bwdrpmx_RestPriceMenu_add_elementor_widget_categories' ] );

		// Register widgets
		add_action( 'elementor/widgets/widgets_registered', [ $this, 'bwdrpmx_register_widgets' ] );

		// Register editor scripts
		add_action( 'elementor/editor/after_enqueue_scripts', [ $this, 'bwdrpmx_admin_editor_scripts' ] );

		add_action('add_eael_progressbar_block', [$this, 'add_box_progress_bar_block'], 10, 3);

		$this->add_page_settings_controls();
	}
}

// Instantiate Plugin Class
Classbwdrpmx_RestPriceMenu::instance();